unit ActiveHandleException;

interface

uses Forms, SysUtils, Classes, Dialogs;

type
  TActiveHandleException = class
  private
    FLogFile: String;
    procedure AppException(Sender: TObject; E: Exception);
  public
    constructor Create;
  end;

implementation

{ TActiveHandleException }

procedure TActiveHandleException.AppException(Sender: TObject;
  E: Exception);
var
  Log: TextFile;
begin
{$I-}
  AssignFile(Log, FLogFile);
  if FileExists(FLogFile) then
    Append(Log)
  else
    Rewrite(Log);
  try
    WriteLn(Log, 'Exception ocorrida em '+
      FormatDateTime('dd" de "mmmm" de "yyyy" s "hh:nn:ss', Now));
    WriteLn(Log,'-------------------------------------------------------------------');
    if TComponent(sender) is TForm then
    begin
      WriteLn(Log,'Form.................: '+ TForm(sender).Name);
      WriteLn(Log,'Caption do Form......: '+TForm(sender).Caption);
    end else
    begin
      WriteLn(Log,'Form.................: '+TForm(TComponent(sender).Owner).Name);
      WriteLn(Log,'Caption do Form......: '+TForm(TComponent(sender).Owner).Caption);
    end;
    WriteLn(Log,'-------------------------------------------------------------------');
    WriteLn(Log,'Classe da Exception..: '+E.ClassName);
    WriteLn(Log,'Mensagem da Exception: '+E.Message);
    WriteLn(Log,'');
    ShowMessage(E.Message);
  finally
    CloseFile(Log);
  end;
{$I+}
end;

constructor TActiveHandleException.Create;
begin
  Application.OnException := AppException;
  FLogFile := ChangeFileExt(ParamStr(0), '.log');
end;

var
  ActiveExcetion: TActiveHandleException;

initialization
  ActiveExcetion := TActiveHandleException.Create;

finalization
  ActiveExcetion.Free;

end.

