CREATE TABLE LOG_SISTEMA (
    LOG_ID INTEGER NOT NULL,
    TABELA VARCHAR(40) NOT NULL,
    REGISTRO VARCHAR(10) NOT NULL,
    OPERACAO VARCHAR(10) NOT NULL,
    RESPONSAVEL VARCHAR(50) NOT NULL,
    DATA DATE NOT NULL);

alter table LOG_SISTEMA
add constraint PK_LOG_SISTEMA
primary key (LOG_ID);

commit work;

CREATE SEQUENCE SEQ_LOG_SISTEMA_ID;

commit work;

create trigger LOG_SISTEMA_BI for LOG_SISTEMA
active before insert position 0
as
begin
  if (new.LOG_ID is null) then
    new.LOG_ID = gen_id(SEQ_LOG_SISTEMA_ID,1);
end;

commit work;

CREATE OR ALTER PROCEDURE SET_VARIAVEL_CONTEXTO (
    USUARIO varchar(50))
as
begin
  RDB$SET_CONTEXT('USER_SESSION', 'USUARIO', USUARIO);
end;

commit work;

CREATE trigger TRG_COUNTRY_BIUD0 for COUNTRY
active after insert or update or delete position 0
AS
begin
  execute procedure INSERIR_LOG ('COUNTRY',
    case when inserting then 'INSERIR'
         when deleting then 'EXCLUIR'
         when updating then 'ALTERAR'
    end,

    case when deleting then old.COUNTRY
    else new.COUNTRY
    end);
end;





