unit WSSegurancaImpl;

interface

uses InvokeRegistry, Types, XSBuiltIns, WSSegurancaIntf;

type

  TWSSeguranca = class(TInvokableClass, IWSSeguranca)
  public
    Function VerAcessoUsuarioSistema(ACodSistema, ACodUsuario : Integer) : Boolean; stdcall;
    Function VerAcessoUsuarioObjeto(ACodSistema, ACodUsuario, ACodObjeto : Integer) : Boolean; stdcall;
  end;

implementation

uses uWDM;

Var
  dm : TWDM;

{ TWSSeguranca }

function TWSSeguranca.VerAcessoUsuarioObjeto(
  ACodSistema, ACodUsuario,ACodObjeto: Integer): Boolean;
// verifica se o usurio do sistema tem permisso ao objeto passado
begin
  Try
    dm := TWDM.Create(Nil);
    dm.sqlUsuarioAcessoObj.Close;
    dm.sqlUsuarioAcessoObj.ParamByName('COD_SISTEMA').AsInteger := ACodSistema;
    dm.sqlUsuarioAcessoObj.ParamByName('COD_USUARIO').AsInteger := ACodUsuario;
    dm.sqlUsuarioAcessoObj.ParamByName('COD_OBJETO').AsInteger := ACodObjeto;
    dm.sqlUsuarioAcessoObj.Open;
    Result := not dm.sqlUsuarioAcessoObj.IsEmpty;
    dm.sqlUsuarioAcessoObj.Close;
    dm.Free;
  Except
    Result := False;
    dm.sqlUsuarioAcessoObj.Close;
    dm.Free;
  End;
end;

function TWSSeguranca.VerAcessoUsuarioSistema(
  ACodSistema,ACodUsuario: Integer): Boolean;
// verifica se o usuario passado tem permisso ao sistema
begin
  Try
    dm := TWDM.Create(Nil);
    dm.sqlUsuarioSistema.Close;
    dm.sqlUsuarioSistema.ParamByName('COD_SISTEMA').AsInteger := ACodSistema;
    dm.sqlUsuarioSistema.ParamByName('COD_USUARIO').AsInteger := ACodUsuario;
    dm.sqlUsuarioSistema.Open;
    Result := not dm.sqlUsuarioSistema.IsEmpty;
    dm.sqlUsuarioSistema.Close;
    dm.Free;
  Except
    Result := False;
    dm.sqlUsuarioSistema.Close;
    dm.Free;
  End;
end;

initialization
   InvRegistry.RegisterInvokableClass(TWSSeguranca);
end.

