//**********************
//funo que retorna o ano, ms, dia, hora, minutos e segundos
//para gerar um ID nico nesta sesso
function getDateTimeAsString()
{
var now = new Date();
return now.getYear().toString() + 
       now.getDate().toString() + 
			 now.getMonth().toString() + 
			 now.getHours().toString() + 
			 now.getMinutes().toString() + 
			 now.getSeconds().toString();
}

//**********************
//instancia o objeto XMLHttpRequest (Ajax) correto,
//de acordo com o navegador em execuo
function openAjax() {	
	var ajax;	
	try {
		ajax = new XMLHttpRequest();
	} catch (ee) {
		try {
			ajax = new ActiveXObject("Msxml12.XMLHTTP");
		} catch (e) {
			try {
				ajax = new ActiveXObject("Microsoft.XMLHTTP");
			} catch (E) {
				ajax = false;
			}
		}
	}
	return ajax;
}

//**********************
//abre uma url com mtodo GET, retornando o conteudo em um div
function AbreUrl(url, div, msg){

  //acrescenta uma string unica na url, para que o navegador
	//no faa cache da requisio
	//se j existe um '?' na url, ento concatena com '&', seno, com '?' mesmo
	if (url.indexOf('?') > 0) {url = url + '&';} else {url = url + '?';}
	url = url + 'nocache=' + getDateTimeAsString();
	
  //se o parmetro msg no foi especificado, utiliza um padro
	if ( (typeof msg == 'undefined') || (msg == '') ) {
    msg = 'Carregando...'; 
	}

	//tenta localizar no documento html o div especificado
	var exibeResultado = document.getElementById(div);
	//se localizou
	if (document.getElementById(div)) {
		//instancia um objeto ajax (funo mais acima)
		var ajax = openAjax();
		//se no conseguiu instanciar o objeto ajax, encerra
		if (!ajax) {
			exibeResultado.innerHTML = 'Seu navegador no suporta Ajax.'			
		}
		//se instanciou o objeto normalmente, continua o procedimento
		else {
		
			//abre a url utilizando o mtodo GET
			ajax.open("GET", url, true);
			//atribui uma funo javacript  funo de callback do objeto ajax
			ajax.onreadystatechange = function() {
				//testa o estado do ajax para ento mostrar a mensagem 
				//personalizada de "Aguarde". Os estados possveis so:
				//0 Uninitialized - Object is not initialized with data.
				//1 Loading - Object is loading its data.
				//2 loaded - Object has finished loading its data.
				//3 interactive - User can interact with the object even though it is not fully loaded. 
				//4 complete - Object is completely initialized.				
				if ( (ajax.readyState == 1) || 
						 (ajax.readyState == 2) || 
						 (ajax.readyState == 3) ){
					 exibeResultado.innerHTML = 
						 '<div align="center" style="color:#000066;">' + 
						 '<br><strong>' + msg + '</strong><br><br>' +
						 '<img src="./loading.gif"><br><br></div>';
				}
				//se o estado  4, est concludo
				if (ajax.readyState == 4) {
					//e se o status http  200, ocorreu com sucesso, ento
					if (ajax.status == 200) {
						//carrega o retorno do objeto ajax no div especificado por parmetro
						var resultado = ajax.responseText;
						resultado = resultado.replace(/\+/g," ");
						resultado = unescape(resultado);
						exibeResultado.innerHTML = resultado;				
					} else { //se no ocorreu com sucesso, mostra a mensagem de erro
						exibeResultado.innerHTML = "Falha na requisio. Cdigo: " + 
																			 ajax.status + " - " + ajax.statusText;
					}
				}				
			}
	  }
		ajax.send(null);
	}  
}

//**********************
//Exibe/Oculta um determinado Div
function ExibeDiv(div, exibir){
    if (exibir) {
      document.getElementById(div).style.display="block";
    } else {
      document.getElementById(div).style.display="none";  
    }
}